/*
 * Panel client to access panel servers.
 *
 * (c) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/cxx/ipc_stream>
#include <l4/re/env>
#include <l4/sys/err.h>

#include "panel-client.h"
#include "panel-ops.h"

#include <stdint.h>

int
Panel_device_interface::get_panel(uint8_t *data, unsigned long datalen) throw()
{
  L4::Ipc::Iostream s(l4_utcb());

  int err = l4_error(s.call(cap(), Panel_op_get_panel));
  if (err) return err;

  // Obtain the message from the stream.

  unsigned long size = datalen;
  s >> L4::Ipc::buf_cp_in<uint8_t>(data, datalen);

  if (size != datalen) return -L4_EIO;
  return L4_EOK;
}
